﻿// dllmain.cpp : DLL アプリケーションのエントリ ポイントを定義します。
#include "pch.h"
#include "DxLib.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}

// ライブラリを初期化する。
extern "C" int __stdcall Dxtest_Init(int DisplayW, int DisplayH, const TCHAR *WindowText, int IconID, int WriteLog = FALSE)
{
  SetOutApplicationLogValidFlag(WriteLog); // ログを出力するかどうか
  SetUseDirectInputFlag(FALSE); // 入力処理にDirectInputを使用するかどうか
  ChangeWindowMode(TRUE); // ウィンドウモードで起動するかどうか
  SetMainWindowText(WindowText); // ウィンドウのタイトル
  //SetWindowIconID(0); // ウィンドウのアイコン

  SetGraphMode(DisplayW, DisplayH, 32);

  if (DxLib_Init() == -1) {
    return -1;
  }
  return 0;
}

// ライブラリを解放する。
extern "C" void __stdcall Dxtest_End(void)
{
  DxLib_End();
}

// メインループ
extern "C" int __stdcall Dxtest_MainLoop(void)
{
  if ((ScreenFlip() == -1) || (ClearDrawScreen() == -1) || (ProcessMessage() == -1)) {
    return -1;
  }
  return 0;
}

