#include <windows.h>

typedef int (WINAPI *TDxtest_Init)(int, int, const TCHAR*, int, int);
typedef void (WINAPI *TDxtest_End)(void);
typedef int (WINAPI *TDxtest_MainLoop)(void);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  HMODULE hModule = LoadLibrary("DxLibSimpleDLL.dll");

  if (hModule == NULL) {
    return -1;
  }

  TDxtest_Init Dxtest_Init = (TDxtest_Init)GetProcAddress(hModule, "Dxtest_Init");
  TDxtest_End Dxtest_End = (TDxtest_End)GetProcAddress(hModule, "Dxtest_End");
  TDxtest_MainLoop Dxtest_MainLoop = (TDxtest_MainLoop)GetProcAddress(hModule, "Dxtest_MainLoop");

  if ((Dxtest_Init == NULL) || (Dxtest_End == NULL) || (Dxtest_MainLoop == NULL)) {
    FreeLibrary(hModule);
    return -1;
  }

  if (Dxtest_Init(800, 600, "eXg", 0, TRUE) == -1) {
    return -1;
  }

  while (Dxtest_MainLoop() == 0) {

  }

  Dxtest_End();
  FreeLibrary(hModule);

  return 0;
}
